// Copyright 2018 by Robert Dick.
// All rights reserved.

#include "Graph.h"
#include <iostream>

using namespace rstd;
using namespace std;

RawGraph::vertex_index
GenChain(RawGraph & g, RawGraph::vertex_index & begin)
{
	RawGraph::vertex_index from = begin;
	for(int i = 0; i < 500000; ++i)
	{
		RawGraph::vertex_index to = g.add_vertex();
		g.add_edge(from, to);
		from = to;
	}
	return g.vertex_offset(g.vertex_end());
}

int main() {
// randomly generate a large DAG
	RawGraph lgraph;
	RawGraph::vertex_index begin1 = lgraph.add_vertex();
	RawGraph::vertex_index end1 = GenChain(lgraph, begin1);

	RawGraph::vertex_index begin2 = lgraph.add_vertex();
	RawGraph::vertex_index end2 = GenChain(lgraph, begin2);

	RawGraph::vertex_index begin3 = lgraph.add_vertex();
	RawGraph::vertex_index end3 = GenChain(lgraph, begin3);

	RawGraph::vertex_index begin4 = lgraph.add_vertex();
	RawGraph::vertex_index end4 = GenChain(lgraph, begin4);

	lgraph.add_edge(begin1, begin2);
	lgraph.add_edge(end1, end2);

	lgraph.add_edge(begin2, begin3);
	lgraph.add_edge(end2, end3);

	lgraph.add_edge(begin3, begin4);
	lgraph.add_edge(end3, end4);

	//top-sort the generated graph and print out the top-sort order
	RVector<RawGraph::vertex_index> top_order = lgraph.top_sort(begin1, false);

	return 0;
}
