/****************************************************************************
**
** ISAC2: Integrated Space and Time Adaptive Chip-Package Thermal Analysis, 
**        version 2.2
**
** Copyright (C) 2018 University of Colorado at Boulder and University 
** of Michigan at Ann Arbor. All rights reserved.
**
** This file is part of ISAC2.
**
** ISAC2 is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation, version 2 of the License.
**
** ISAC2 is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with ISAC2 in the file COPYING.  If not, see 
** <http://www.gnu.org/licenses/>.
**
** For feedback, comments, or questions, please contact Zyad Hassan 
** (zyad.hassan@colorado.edu) and Xi Chen (chexi@umich.edu)
**
** Please contact the authors if you are interested in making commercial
** use of ISAC2.  It may be possible to re-release under a different license.
****************************************************************************/

/****************************************************************************
** header.h: header file for the device solver
****************************************************************************/

#ifndef BIG_H
#define BIG_H

#include <iostream>
#include <cstring>
#include <sstream>
#include <string> 
#include <cmath>
#include <fstream>
#include <sys/time.h>
#include <vector>
#include <stdio.h>
#include <stdlib.h>

//Constants
#define PI atan2(0,-1)
#define CONSTe 160.2176462e-21 //elemental charge
#define TEMP_ERROR 1e-4 //the allowed error in temperature

const int E_ = 0;
const int W_ = 1;
const int N_ = 2;
const int S_ = 3;
const int T_ = 4;
const int B_ = 5;
//int iterations;

using namespace std;

#include "def.h"

//The TDMA loop

void Tdma(vector<double> &coeffVector1,vector<double>
&coeffVector2,vector<double> &coeffVector3,vector<double>
&bVector,vector<double> &energyVector);

void Tdma_f(vector<double> &coeffVector1,vector<double>
&coeffVector2,vector<double> &coeffVector3,vector<int>
&lockVector,vector<double> &bVector,vector<double> &energyVector);

#endif
